//generated array coppying created in MatrixArrayGenerator by james bellafaire

unsigned long animationTimer = 0;

void changeImage() {
  /*if interruptFlag and a interrupt hasn't been triggered in the last 50ms and PC2 reads a high value */
  if (interruptFlag && micros() > 50000 + lastInterrupt && PINC & (1 << PC2)) {

    interruptFlag = false;

    //we know when the last rotation was and we know when now is
    //so lets make sure the frame displays for the right amount of
    //time for our current speed
    frameDisplayTime =  recalcAnimationTime(lastInterrupt, micros());

    //store again
    lastInterrupt = micros();
  } else {
    interruptFlag = false; //because that was a false positive (probably noise)
  }

  if (micros() > Time + frameDisplayTime) {
    Time = micros();
    currentPositionInArrays++;
    if (currentPositionInArrays >= 5) {
      currentPositionInArrays = 0;
    }

    if(millis() >= animationTimer + animationDisplayTime){
      animationTimer = millis();
      animationCount++; 
      if(animationCount*5 >= totalFrames){
        animationCount = 0; 
      }
    }
  

    //move from flash storage to ram
    memcpy_PF(RenderImage, array0[currentPositionInArrays + animationCount*5] , 110);

  }
}

/*each rotation is timed and compared with the animationDisplayTime variable
   this function determines whether the next rotation's frames need to be
   displayed faster or slower than the previous rotation, this prevents
   sudden speedups or slowdowns from causing the image to rotate */
void alignmentAdjustC(int pos, unsigned long oldTime) {
  if (pos == 0) {
    frameDisplayTime += (oldTime - frameUptime) * 5;
  }
  if (pos == 4) {
    frameDisplayTime -= (oldTime - frameUptime) * 5;
  }
}

